﻿@page "/users/rating/"
@using Microsoft.Extensions.Localization
@using Microsoft.EntityFrameworkCore
@using Sirkadirov.Overtest.SharedLibraries.ODataStoreLib.Models.TasksArchive
@using System.Threading
@using Microsoft.AspNetCore.WebUtilities

@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IStringLocalizer<UsersRating> _localizer
@inject NavigationManager _navigationManager

<MudContainer MaxWidth="MaxWidth.Large" Class="py-3">
    <MudText Typo="Typo.h5" Style="font-weight: bold;">@_localizer["Рейтинг користувачів"]</MudText>
    <MudPaper Outlined="true" Class="pa-3 mt-3 mb-0">
        <MudGrid>
            <MudItem xs="12" md="3">
                <MudTextField Label="@_localizer["Повне ім'я користувача"]" Variant="Variant.Outlined"
                              Margin="Margin.Dense" Clearable="true" @bind-Value="_searchByFullName"></MudTextField>
            </MudItem>
            
            <MudItem xs="6" md="3">
                <MudTextField Label="@_localizer["Заклад освіти"]" Variant="Variant.Outlined"
                              Margin="Margin.Dense" Clearable="true" @bind-Value="_searchByInstitutionName"></MudTextField>
            </MudItem>
            
            <MudItem xs="6" md="3">
                <MudSelect Label="@_localizer["Куратор"]" Variant="Variant.Outlined"
                           Margin="Margin.Dense" Clearable="true" @bind-Value="_searchByCuratorId" T="Guid?">
                    @foreach (var (curatorId, curatorFullName) in _curatorsList)
                    {
                        <MudSelectItem T="Guid?" Value="@curatorId">@curatorFullName</MudSelectItem>
                    }
                </MudSelect>
            </MudItem>
            
            <MudItem xs="12" md="3">
                <MudButton Variant="Variant.Filled" Color="Color.Primary" Size="Size.Large" DisableElevation="true" FullWidth="true"
                           StartIcon="@Icons.Material.Filled.Search" Style="height: 45px;" OnClick="ExecuteSearchAsync">@_localizer["Пошук"]</MudButton>
            </MudItem>
        </MudGrid>
    </MudPaper>
</MudContainer>

@* Search results container *@
<MudContainer MaxWidth="MaxWidth.Large" class="py-3">
    @if (_searchResults == null)
    {
        <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="300px" />
    }
    else if (_searchResults.Count <= 0)
    {
        <MudAlert Severity="Severity.Info" Elevation="0">
            @_localizer["За вашим запитом, на жаль, нічого не знайдено. Спробуйте змінити параметри пошуку, або почніть пошук з чистого аркуша."]
        </MudAlert>
    }
    else
    {
        <MudTable Items="@_searchResults" Hover="true" Breakpoint="Breakpoint.None" Outlined="true" Elevation="0" Class="mb-3">
            <HeaderContent>
                <MudTh Style="white-space: nowrap;">@_localizer["#"]</MudTh>
                <MudTh Style="white-space: nowrap;">@_localizer["Повне ім'я"]</MudTh>
                <MudTh Style="white-space: nowrap;">@_localizer["Заклад освіти"]</MudTh>
                <MudTh Style="white-space: nowrap;">@_localizer["Куратор"]</MudTh>
                <MudTh Style="white-space: nowrap; text-align: center;">@_localizer["Рейтинг"]</MudTh>
            </HeaderContent>
            <RowTemplate>
                <MudTd>@context.NumberInList</MudTd>
                <MudTd Class="d-flex justify-start align-center" Style="white-space: nowrap;">
                    <MudLink Href="@($"/users/profile/{context.Id}")" Style="white-space: nowrap;">@context.FullName</MudLink>
                    @if (context.UserType == UserType.SuperUser)
                    {
                        <MudChip Size="Size.Small" Color="Color.Error">@_localizer["Суперадмін"]</MudChip>
                    }
                    else if (context.UserType == UserType.Curator)
                    {
                        <MudChip Size="Size.Small" Color="Color.Info">@_localizer["Куратор"]</MudChip>
                    }
                    else if (context.UserType == UserType.Student)
                    {
                        <MudChip Size="Size.Small">@_localizer["Студент"]</MudChip>
                    }
                </MudTd>
                <MudTd Style="white-space: nowrap;">
                    @if (context.InstitutionName is not null)
                    {
                        <MudLink Href="javascript://void(0)" @onclick="@(() => OnInstitutionNameLinkClicked(context.InstitutionName))" Style="white-space: nowrap;">@context.InstitutionName</MudLink>
                    }
                    else
                    {
                        @("Відсутній")
                    }
                </MudTd>
                <MudTd Style="white-space: nowrap;">
                    @if (context.CuratorId is not null)
                    {
                        <MudLink Style="white-space: nowrap;" Href="@($"/users/profile/{context.CuratorId}")">@context.CuratorFullName</MudLink>
                    }
                    else
                    {
                        @_localizer["Відсутній"]
                    }
                </MudTd>
                <MudTd Style="font-weight: bold; text-align: center;">@context.Rating</MudTd>
            </RowTemplate>
            <PagerContent>
                <MudPagination SelectedChanged="OnPaginationSelectedPageChangedAsync" Count="@_searchResultsPagesCount" Class="pa-4"/>
            </PagerContent>
        </MudTable>
    }
</MudContainer>
@* /Search results container *@

@code {
    private SemaphoreSlim _semaphore;
    
    private string _searchByFullName;
    private string _searchByInstitutionName;
    private Guid? _searchByCuratorId;
    
    private const int SearchResultsItemsPerPage = 30;
    private List<UsersRatingListItemModel> _searchResults;
    private int _searchResultsCount;
    private int _searchResultsPagesCount;
    private int _searchResultsCurrentPage;
    
    private Dictionary<Guid, string> _curatorsList;

    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        _curatorsList = new Dictionary<Guid, string>();

        _searchResultsCount = 0;
        _searchResultsPagesCount = 1;
        _searchResultsCurrentPage = 1;
    }
    
    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        await base.OnAfterRenderAsync(firstRender);

        if (!firstRender)
            return;

        _semaphore = new SemaphoreSlim(1, 1);
        
        await FetchQueryParametersAsync();
        await FetchCuratorsListAsync();
        StateHasChanged();
        
        await ExecuteSearchAsync();
        StateHasChanged();
    }

    private void OnInstitutionNameLinkClicked(string institutionName)
    {
        _navigationManager.NavigateTo($"/users/rating/?institution={institutionName}", true);
    }

    private async Task OnPaginationSelectedPageChangedAsync(int currentPage)
    {
        if (_searchResultsCurrentPage == currentPage)
            return;
        
        _searchResultsCurrentPage = currentPage;
        await ExecuteSearchAsync();
    }

    private async Task FetchQueryParametersAsync()
    {
        // Get query parameters
        var queryDictionary = QueryHelpers.ParseQuery(_navigationManager.ToAbsoluteUri(_navigationManager.Uri).Query);
        
        // Fetching user's full name from query
        if (queryDictionary.TryGetValue("fullname", out var queryFUllName))
        {
            if (!string.IsNullOrWhiteSpace(queryFUllName))
            {
                _searchByFullName = queryFUllName;
            }
        }
        
        // Fetching institution name from query
        if (queryDictionary.TryGetValue("institution", out var queryInstitutionName))
        {
            if (!string.IsNullOrWhiteSpace(queryInstitutionName))
            {
                _searchByInstitutionName = queryInstitutionName;
            }
        }
        
        // Fetching curator ID from query
        if (queryDictionary.TryGetValue("curator", out var queryCuratorId))
        {
            if (!string.IsNullOrWhiteSpace(queryCuratorId) && Guid.TryParse(queryCuratorId, out var curatorId))
            {
                await using var databaseContext = _dbContextFactory.CreateDbContext();

                if (await databaseContext.Users.AnyAsync(u => u.Id == curatorId && u.Type != UserType.Student))
                    _searchByCuratorId = curatorId;
            }
        }
    }

    private async Task FetchCuratorsListAsync()
    {
        await _semaphore.WaitAsync();
        try
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();

            _curatorsList = await databaseContext.Users.AsNoTracking()
                .Where(u => u.Type == UserType.Curator || u.Type == UserType.SuperUser).OrderBy(u => u.FullName)
                .ToDictionaryAsync(key => key.Id, value => value.FullName);
        }
        finally { _semaphore.Release(); }
    }
    
    private async Task ExecuteSearchAsync()
    {
        if (_semaphore.CurrentCount < 1)
            return;
        
        await _semaphore.WaitAsync();
        
        _searchResultsCount = 0;
        _searchResultsPagesCount = 1;

        if (_searchResults is not null)
        {
            _searchResults = null;
            StateHasChanged();
        }

        await using var databaseContext = _dbContextFactory.CreateDbContext();

        if (string.IsNullOrWhiteSpace(_searchByFullName))
            _searchByFullName = null;

        if (string.IsNullOrWhiteSpace(_searchByInstitutionName))
            _searchByInstitutionName = null;

        var searchQuery = (
            from user in databaseContext.Users.AsNoTracking().Include(i => i.Curator)
            where _searchByCuratorId == null || user.CuratorId == _searchByCuratorId
            where _searchByFullName == null || EF.Functions.Like(user.FullName, $"%{_searchByFullName}%")
            where _searchByInstitutionName == null || EF.Functions.Like(user.InstitutionName, $"%{_searchByInstitutionName}%")
            join solution in databaseContext.ProgrammingTaskSolutions.AsNoTracking()
                on user.Id equals solution.AuthorId into solutions
            from solution in solutions
                .Where(s => s.VerificationStatus == TaskSolution.SolutionVerificationStatus.Verified)
                .Where(s => s.VerificationType == TaskSolution.SolutionVerificationType.ReleaseMode)
                .Where(s => s.Adjudgement != TaskSolution.SolutionAdjudgementType.NoAdjudgement)
                .Where(s => s.Adjudgement != TaskSolution.SolutionAdjudgementType.ZeroSolution)
                .DefaultIfEmpty()
            select new
            {
                user.Id, user.Type,
                user.FullName, user.InstitutionName,
                user.CuratorId, CuratorFullName = user.Curator.FullName,
                solution.GivenRating
            }
            into selectedData
            group selectedData by new
            {
                selectedData.Id, selectedData.Type,
                selectedData.FullName, selectedData.InstitutionName,
                selectedData.CuratorId, selectedData.CuratorFullName
            }
            into groupedData
            select new UsersRatingListItemModel
            {
                Id = groupedData.Key.Id, UserType = groupedData.Key.Type,
                FullName = groupedData.Key.FullName, InstitutionName = groupedData.Key.InstitutionName,
                CuratorId = groupedData.Key.CuratorId, CuratorFullName = groupedData.Key.CuratorFullName,
                Rating = groupedData.Sum(sum => sum.GivenRating)
            })
            .OrderByDescending(order => order.Rating)
            .ThenBy(order => order.FullName)
            .AsNoTracking();

        _searchResultsCount = await searchQuery.CountAsync();

        if (_searchResultsCount <= 0)
        {
            _searchResultsCurrentPage = 1;
            _searchResults = new List<UsersRatingListItemModel>();
        }
        else
        {
            _searchResultsPagesCount = (int)Math.Ceiling(_searchResultsCount / (double)SearchResultsItemsPerPage);
            var previousItemsCount = (_searchResultsCurrentPage - 1) * SearchResultsItemsPerPage;
            if (_searchResultsCurrentPage > _searchResultsPagesCount)
                _searchResultsCurrentPage = 1;
        
            _searchResults = await searchQuery
                .Skip(previousItemsCount)
                .Take(SearchResultsItemsPerPage)
                .ToListAsync();

            var numberInList = 0;
            _searchResults.ForEach(model => model.NumberInList = ++numberInList + ((_searchResultsCurrentPage - 1) * SearchResultsItemsPerPage));
        }

        _semaphore.Release();
    }

    private class UsersRatingListItemModel
    {
        public int NumberInList { get; set; }
        
        public Guid Id { get; init; }
        public string FullName { get; init; }
        public string InstitutionName { get; init; }
        public UserType UserType { get; init; }
        
        public Guid? CuratorId { get; init; }
        public string CuratorFullName { get; init; }
        
        public int Rating { get; init; }
    }
}